routes/web.php
<?php

use App\Invoice;
use App\Payment;
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
/* Front-End Routes */
Route::get('/', function () {
    return view('welcome');
})->name('/');


Route::get('/signup', function () {
    return view('signup');
})->name('signup')->middleware('guest');

Route::resource('/user', 'UsersController');


Route::get('/login', function () {
    return view('login');
})->name('login');

Route::get('/pricing', function () {
    return view('pricing');
})->name('pricing');

Route::get('/account', function () {

    $invoices=Invoice::where('user_id',auth()->user()->id)->get()->all();
    $totalInvoices=count($invoices);
    $userPlanEndsOn=Payment::select('payment_end_date')->where('user_id',auth()->user()->id)->get()->all();
    $userPlanEndsOn=$userPlanEndsOn[0]->payment_end_date;
    return view('account',compact('totalInvoices','userPlanEndsOn'));
})->name('account');

Route::get('/about-us', function () {
    return view('about-us');
})->name('about-us');

Route::resource('/invoice','InvoiceController');

Route::get('pdf/{id}','InvoiceController@GeneratePdf')->name('pdf');

Route::post('search','InvoiceController@InvoiceSearch')->name('search');

Route::get('paystack-callback-url','UsersController@paystackCallBack');




/* Admin Routes */

Route::group(['prefix' => 'admin'], function () {
    Voyager::routes();
});




Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Invoice.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Invoice extends Model
{
   protected $fillable=['user_id','inv_number','seller_id','inv_currency','inv_type','inv_tax_per','inv_dis_per','inv_tax_type','inv_status','purchaser_id','inv_logo','inv_signature'];

   public  function user(){

       return $this->belongsTo(User::class);

   }

    public  function item(){
       return $this->hasMany(Item::class);
    }
    public function seller(){
       return $this->belongsTo(Seller::class);
    }
    public function purchaser(){
       return $this->belongsTo(Purchaser::class);
    }
}

app/Http/Controllers/InvoiceController.php
<?php

namespace App\Http\Controllers;

use App\Invoice;
use App\Item;
use App\Purchaser;
use App\Seller;
use Barryvdh\DomPDF\PDF;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Input;

class InvoiceController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function __construct()
    {
        $this->middleware('auth')->except(['create']);
    }

    public function index()
    {
        $invoiceData=Invoice::where('user_id',auth()->user()->id)->orderBy('id','DESC')->paginate(10);
        //dd($invoiceData);
        return view('invoice.index',compact('invoiceData'));

    }

    public function create()
    {
        return view('invoice.create');
    }

    public function store(Request $request)
    {
        if(isset($_POST['img_data'])){
        $imagedata = base64_decode($_POST['img_data']);
	    $signature = md5(date("dmYhisA"));
	    $sig_name = 'inovieLogos/'.$signature.'.png';
        file_put_contents($sig_name,$imagedata);
         $sig_name=$signature.'.png';         
        }else{
         $sig_name=''; 
        }
        $logo = isset($request['logo']) ? $request['logo']:0;
        if($logo){
            $orignalName= $logo->getClientOriginalName();
            $name= time().rand('00000000','99999999').$orignalName;
            $logo->move('inovieLogos',$name);
            $logoFile = $name;
        }else{
            $logoFile='';
        }

        $purchaser=Purchaser::create([
            'pur_name'=>$request->purName,
            'pur_address'=>$request->purAddress,
            'pur_tax_id'=>$request->purTaxId,
            'pur_date'=>$request->purDate,
            'pur_status'=>'1',
        ]);


        $seller=Seller::create([
            'seller_name'=>$request->sellerName,
            'seller_phone'=>$request->sellerPhn,
            'seller_address'=>$request->sellerAddress,
            'user_id'=>auth()->user()->id,
            'seller_tax_id'=>$request->sellerTaxId,
            'seller_co_information'=>$request->sellerCoInfo,
            'seller_status'=>'1',
        ]);

        if($seller!==null && $purchaser!==null){

            $invoice=Invoice::create([
                'user_id'=>auth()->user()->id,
                'seller_id'=>$seller->id,
                'inv_number'=>$request->invoiceNumber,
                'inv_currency'=>$request->currency,
                'inv_type'=>$request->invoiceType,
                'inv_dis_per'=>$request->disRate,
                'inv_tax_type'=>$request->taxType,
                'inv_tax_per'=>$request->taxRate,
                'purchaser_id'=>$purchaser->id,
                'inv_logo'=>$logoFile,
                'inv_signature'=>$sig_name,
                'inv_status'=>'1',

            ]);
           if($invoice!==null){


                  for($i=0;$i<count($request->itemName);$i++){

                      Item::create([
                          'inv_item_name'=>$request->itemName[$i],
                          'inv_item_price'=>$request->itemPrice[$i],
                          'inv_item_quantity'=>$request->itemQty[$i],
                          'invoice_id'=>$invoice->id,
                          'inv_item_status'=>'1',
                      ]);

                  }



               return redirect()->back()->with('success','Invoice Created Successfully, You can see it your Account Dashboard!');
           }else{
               return redirect()->back()->with('error','Something Went Wrong Please Try Again!');
           }
        }else{
            return redirect()->back()->with('error','Something Went Wrong Please Try Again!');
        }
    }


    public function show($id)
    {
        $invoice=Invoice::where('id',$id)->get()->first();
        return view('invoice.showinvoice',compact('invoice'));
    }


    public function edit($id)
    {
        $invoiceData=Invoice::where('id',$id)->get()->first();
        return view('invoice.edit',compact('invoiceData'));
    }

    public function update(Request $request, $id)
    {

        if(isset($_POST['img_data'])){
        $imagedata = base64_decode($_POST['img_data']);
	    $signature = md5(date("dmYhisA"));
	    $sig_name = 'inovieLogos/'.$signature.'.png';
        file_put_contents($sig_name,$imagedata);
         $sig_name=$signature.'.png';         
        }else{
         $sig_name=''; 
        }
        $invoicereq=Invoice::where('id',$id)->get()->first();

        $purchaser=Purchaser::findorfail($invoicereq->purchaser_id)->update([
            'pur_name'=>$request->purName,
            'pur_address'=>$request->purAddress,
            'pur_tax_id'=>$request->purTaxId,
            'pur_date'=>$request->purDate,
            'pur_status'=>'1',
        ]);


        $seller=Seller::findorfail($invoicereq->seller_id)->update([
            'seller_name'=>$request->sellerName,
            'seller_phone'=>$request->sellerPhn,
            'seller_address'=>$request->sellerAddress,
            'user_id'=>auth()->user()->id,
            'seller_tax_id'=>$request->sellerTaxId,
            'seller_co_information'=>$request->sellerCoInfo,
            'seller_status'=>'1',
        ]);

        if($seller!==null && $purchaser!==null){
            $logo = isset($request['logo']) ? $request['logo']:0;
            if($logo){
                $orignalName= $logo->getClientOriginalName();
                $name= time().rand('00000000','99999999').$orignalName;
                $logo->move('inovieLogos',$name);
                $logoFile = $name;

                $invoice=Invoice::findorfail($invoicereq->id)->update([
                    'user_id'=>auth()->user()->id,
                    'seller_id'=>$invoicereq->seller_id,
                    'inv_number'=>$request->invoiceNumber,
                    'inv_currency'=>$request->currency,
                    'inv_type'=>$request->invoiceType,
                    'inv_dis_per'=>$request->disRate,
                    'inv_tax_type'=>$request->taxType,
                    'inv_tax_per'=>$request->taxRate,
                    'purchaser_id'=>$invoicereq->purchaser_id,
                    'inv_logo'=>$logoFile,
                    'inv_signature'=>$sig_name,
                    'inv_status'=>'1',

                ]);
            }
            else{
                $invoice=Invoice::findorfail($invoicereq->id)->update([
                    'user_id'=>auth()->user()->id,
                    'seller_id'=>$invoicereq->seller_id,
                    'inv_number'=>$request->invoiceNumber,
                    'inv_currency'=>$request->currency,
                    'inv_type'=>$request->invoiceType,
                    'inv_dis_per'=>$request->disRate,
                    'inv_tax_type'=>$request->taxType,
                    'inv_tax_per'=>$request->taxRate,
                    'purchaser_id'=>$invoicereq->purchaser_id,
                    'inv_signature'=>$sig_name,
                    'inv_status'=>'1',

                ]);
            }


            if($invoice!==null){
                for($i=0;$i<count($request->itemName);$i++){
                    Item::where('id',$request->itemId[$i])->update([
                        'inv_item_name'=>$request->itemName[$i],
                        'inv_item_price'=>$request->itemPrice[$i],
                        'inv_item_quantity'=>$request->itemQty[$i],
                        'invoice_id'=>$invoicereq->id,
                        'inv_item_status'=>'1',
                    ]);

                }


                return redirect('invoice')->with('success','Invoice Created Successfully, You can see it your Account Dashboard!');
            }else{
                return redirect()->back()->with('error','Something Went Wrong Please Try Again!');
            }
        }else{
            return redirect()->back()->with('error','Something Went Wrong Please Try Again!');
        }
    }

    public function destroy($id)
    {
        //
    }

    public function GeneratePdf($id){
        $invoice=Invoice::where('id',$id)->get()->first();
//        return view('invoice.invoicepdf',compact('invoice'));
        $pdf = \PDF::loadView('invoice.invoicepdf',compact('invoice'));
        return $pdf->download('invoice'.$invoice->inv_number.'.pdf');
    }

    public function InvoiceSearch(Request $request)
    {
        $q = Input::get ('search');
        $user_id=auth()->user()->id;
        $invoice = Invoice::where ( 'id', '=', $q )->orWhere ( 'inv_number', '=',$q)->where('user_id',$user_id)->get();
        if (count ( $invoice ) > 0)
            return view ( 'invoice.search',compact('invoice','q') );
        else
            return view ( 'invoice.search',compact('invoice','q') );
    }
//
//        if ($request->ajax()) {
//            $output = "";
//            $invoice = DB::table('Invoice')->where('id', 'LIKE', '%' . $request->search . "%")->get();
//            if ($invoice) {
//                foreach ($invoice as $key => $inv) {
//                    $output .= '<tr>' .
//                        '<td>' . $inv->id . '</td>' .
//                        '<td>' . $inv->inv_number . '</td>' .
//                        '<td>' . $inv->inv_type . '</td>' .
//                        '<td>' . $inv->inv_currency . '</td>' .
//                        '</tr>';
//                }
//                return Response($output);
//            }
//        }
//    }

}

resources/views/invoice/index.blade.php
@extends('layouts.master')
@section('headerbox')
    <!--PRICING AREA-->
    <section style="background-image: linear-gradient(to bottom, #1193d4 , transparent,transparent,transparent,transparent);" class="price-area padding-100-70 sky-gray-bg" id="pricing">
        <div class="container">
            <br>
            <br>
            <div class="row">
                <div class="col-md-3">
                    <div class="list-group">
                        <a href="{{route('account')}}" class="list-group-item">Dashboard</a>
                        <a href="{{route('invoice.index')}}" class="list-group-item active">Invoices</a>
                        <a href="#" class="list-group-item">Settings</a>
                    </div>
                </div>
                <div class="col-md-9">
                    <div class="table-responsive">
                        <form action="{{route('search')}}" class="search-form" method="POST" role="search" style="border: 2px solid #1193d4;">
                            @csrf
                            <input type="search" name="search" id="search" placeholder="Invoice Serial Number">
                            <button type="submit">
                                <i class="fa fa-search"></i>
                            </button>
                        </form>
                        <table class="table">
                            <thead>
                            <tr>
                                <th>Sr No.</th>
                                <th>Invoice No.</th>
                                <th>Purchaser Name</th>
                                <th>Purchaser Email</th>
                                <th>Items</th>
                                <th>Invoice Total</th>
                                <th>Created</th>
                                <th>Actions</th>
                            </tr>
                            </thead>
                            <tbody>
                        @php $i=1; $itemsTotal=0;$taxTotal=0; $discountTotal=0; @endphp
                           @foreach($invoiceData as $inv)

                            <tr>
                                <td>{{$inv->id}}</td>
                                <td>{{$inv->inv_number}}</td>
                                <td>{{$inv->purchaser->pur_name}}</td>
                                <td>purchaser mail</td>
                                <td>
                                    <ul style="font-size: 10px; font-weight:bolder;">
                                    @foreach($inv->item as $item)
                                      <li>{{$item->inv_item_name}}</li>
                                         @php $itemsTotal=$itemsTotal+$item->inv_item_price*$item->inv_item_quantity @endphp
                                    @endforeach
                                    </ul>
                                </td>
                                @php $taxTotal=$itemsTotal+(($inv->inv_tax_per/100)*$itemsTotal)@endphp
                                <td>{{$discountTotal=$taxTotal-(($inv->inv_dis_per/100)*$taxTotal)}} {{$inv->inv_currency}}</td>
                                <td>{{$inv->created_at->diffForHumans()}}</td>
                                <td><a href="{{route('invoice.edit',$inv->id)}}"><i class="fa fa-edit"></i></a>&nbsp;&nbsp;&nbsp;<a href="{{route('invoice.show',$inv->id)}}"><i class="fa fa-eye"></i></a>&nbsp;&nbsp;&nbsp;<a href="{{route('pdf',$inv->id)}}"><i class="fa fa-download"></i></a></td>

                            </tr>
                            @endforeach
                            </tbody>
                        </table>
                        <span>{{$invoiceData->onEachSide(1)->links()}}</span>
                    </div>
                </div>



            </div>
        </div>
    </section>
    <!--PRICING AREA END-->
@endsection

@section('script')
    <script type="text/javascript">
        $('#search').on('keyup',function(){
            $value=$(this).val();
            $.ajax({
                type : 'get',
                url : '{{route('search')}}',
                data:{'search':$value},
                success:function(data){
                    $('tbody').html(data);
                }
            });
        })
    </script>
    <script type="text/javascript">
        $.ajaxSetup({ headers: { 'csrftoken' : '{{ csrf_token() }}' } });
    </script>
@endsection()

resources/views/invoice/invoicepdf.blade.php
<table width="100%" style="margin:auto;">
    <tr>
        <td>
            <table width="100%" style="border-bottom:2px solid black;padding-bottom: 5px;">
                <tr>
                    <td align="right">{{$invoice->seller->seller_name}}</td>
                </tr>
                <tr>
                    <th align="center"><h1>Retail Invoice/Bil</h1></th>
                </tr>
                <tr>
                    <th align="center"><img src="{{asset('inovieLogos')}}/{{$invoice->inv_logo}}" style="width: 150px;height: 100px;object-fit:contain;"></th>
                </tr>
                <br/>
                <tr>
                    <td align="center">{{$invoice->seller->seller_address}}</td>
                </tr>
                <tr>
                    <td align="center">TIN:{{$invoice->seller->seller_tax_id}}</td>
                </tr>
            </table>
        </td>
    </tr>
    <tr>
        <td>
            <table width="100%" style="border-bottom:2px solid black;margin-bottom: 10px;padding-bottom: 10px;">
                <tr>
                    <th>Invoice: {{$invoice->inv_number}}</th>
                    <th>{{$invoice->purchaser->pur_name}}</th>
                </tr>
                <tr>
                    <td>Date: {{date('d-m-Y')}}</td>
                    <td>{{$invoice->purchaser->pur_address}}</td>
                </tr>
                <tr>
                    <td></td><td>TIN/PAN:{{$invoice->purchaser->pur_tax_id}}</td>
                </tr>
            </table>
        </td>
    </tr>

    <tr>
        <td>
            <table width="100%" style="margin-bottom: 50px;">
                <tr>
                    <th style="border-bottom: 2px solid black;" align="center">Sr</th><th style="border-bottom: 2px solid black;" align="center">Name</th><th style="border-bottom: 2px solid black;" align="center">Price</th><th style="border-bottom: 2px solid black;" align="center">Quantity</th><th style="border-bottom: 2px solid black;" align="center">Amount</th>
                </tr>
                @php $i=1; $itemsTotal=0;$taxTotal=0; $discountTotal=0; @endphp
                @foreach($invoice->item as $item)
                <tr>
                    <td align="center" style="border-bottom: 1px solid #ddd;">{{$i++}}</td>
                    <td align="center" style="border-bottom: 1px solid #ddd;">{{$item->inv_item_name}}</td>
                    <td align="center" style="border-bottom: 1px solid #ddd;">{{$item->inv_item_price}}</td>
                    <td align="center" style="border-bottom: 1px solid #ddd;">{{$item->inv_item_quantity}}</td>
                    <td align="center" style="border-bottom: 1px solid #ddd;">{{$item->inv_item_price* $item->inv_item_quantity}}</td>
                    @php $itemsTotal=$itemsTotal+($item->inv_item_price* $item->inv_item_quantity) @endphp
                </tr>
                @endforeach
                <tr>
                    <td colspan="3" style="border-bottom: 1px solid #ddd;"></td><th style="border-bottom: 1px solid #ddd;" align="center">Total</th><th style="border-bottom: 1px solid #ddd;" align="center">{{$itemsTotal}}</th>
                </tr>
                <tr>
                    <td colspan="3" style="border-bottom: 1px solid #ddd;"></td><td style="border-bottom: 1px solid #ddd;" align="center">Discount({{$invoice->inv_dis_per}}%)</td><td style="border-bottom: 1px solid #ddd;" align="center">{{$discount=($itemsTotal/100)*$invoice->inv_dis_per}}</td>
                </tr>
                <tr>
                    <td colspan="3" style="border-bottom: 1px solid #ddd;"></td><th style="border-bottom: 1px solid #ddd;" align="center">Total</th> <th style="border-bottom: 1px solid #ddd;" align="center">{{$discountTotal=$itemsTotal-$discount}}</th>
                </tr>
                <tr>
                    <td colspan="3" style="border-bottom: 1px solid #ddd;"></td><td style="border-bottom: 1px solid #ddd;" align="center">{{$invoice->inv_tax_type}}({{$invoice->inv_tax_per}}%)</td><td style="border-bottom: 1px solid #ddd;" align="center">{{$tax=($discountTotal/100)*$invoice->inv_tax_per}}</td>
                </tr>
                <tr>
                    <td colspan="3" style="border-bottom: 1px solid #ddd;"></td><th style="border-bottom: 1px solid #ddd;" align="center">Total Payable amount</th><th style="border-bottom: 1px solid #ddd;" align="center">{{$tax+$discountTotal}}</th>
                </tr>

            </table>
        </td>
    </tr>

    <tr>
        <td>
            <table width="100%">
                <tr>
                    <td>
                        <h3>Terms & Conditions</h3>
                        <ol style="font-size: 10px;">

                            <li>Goods once sold cannot be taken back.</li>
                            <li>Interest @18% pa chargeable on bills unpaid for more than 15 days.</li>
                            <li>Dispute will be under Delhi jurisdiction.</li>
                            <li>This is a computer generated invoice and is not valid without authority signatures.</li>
                            <li>E & OE</li>

                        </ol>
                    </td>
                    <th style="text-align:right;"><img src="{{asset('inovieLogos')}}/{{$invoice->inv_signature}}" style="height:100px; width:200px; object-fit:contain;" /></th>
                </tr>
                <tr>
                    <td>
                        
                    </td>
                    <td align="right"><span style="color: red">For {{$invoice->seller->seller_name}}</span></td>
                </tr>
            </table>
        </td>
    </tr>

</table>

resources/views/invoice/search.blade.php
@extends('layouts.master')
@section('headerbox')
    <!--PRICING AREA-->
    <section style="background-image: linear-gradient(to bottom, #1193d4 , transparent,transparent,transparent,transparent);" class="price-area padding-100-70 sky-gray-bg" id="pricing">
        <div class="container">
            <br>
            <br>
            <div class="row">
                <div class="col-md-3">
                    <div class="list-group">
                        <a href="{{route('account')}}" class="list-group-item">Dashboard</a>
                        <a href="{{route('invoice.index')}}" class="list-group-item active">Invoices</a>
                        <a href="#" class="list-group-item">Settings</a>
                    </div>
                </div>
                <div class="col-md-9">
                    <div class="table-responsive">
                        <form action="{{route('search')}}" class="search-form" method="POST" role="search" style="border: 2px solid #1193d4;">
                            @csrf
                            <input type="search" name="search" id="search" placeholder="Invoice Serial Number" value="{{$q}}">
                            <button type="submit">
                                <i class="fa fa-search"></i>
                            </button>
                        </form>
                        <table class="table">
                            <thead>
                            <tr>
                                <th>Sr No.</th>
                                <th>Invoice No.</th>
                                <th>Purchaser Name</th>
                                <th>Purchaser Email</th>
                                <th>Items</th>
                                <th>Invoice Total</th>
                                <th>Created</th>
                                <th>Actions</th>
                            </tr>
                            </thead>
                            <tbody>
                            @php $i=1; $itemsTotal=0;$taxTotal=0; $discountTotal=0; @endphp
                            @forelse($invoice as $inv)

                                <tr>
                                    <td>{{$inv->id}}</td>
                                    <td>{{$inv->inv_number}}</td>
                                    <td>{{$inv->purchaser->pur_name}}</td>
                                    <td>purchaser mail</td>
                                    <td>
                                        <ul style="font-size: 10px; font-weight:bolder;">
                                            @foreach($inv->item as $item)
                                                <li>{{$item->inv_item_name}}</li>
                                                @php $itemsTotal=$itemsTotal+$item->inv_item_price*$item->inv_item_quantity @endphp
                                            @endforeach
                                        </ul>
                                    </td>
                                    @php $taxTotal=$itemsTotal+(($inv->inv_tax_per/100)*$itemsTotal)@endphp
                                    <td>{{$discountTotal=$taxTotal-(($inv->inv_dis_per/100)*$taxTotal)}} {{$inv->inv_currency}}</td>
                                    <td>{{$inv->created_at->diffForHumans()}}</td>
                                    <td><a href="{{route('invoice.edit',$inv->id)}}"><i class="fa fa-edit"></i></a>&nbsp;&nbsp;&nbsp;<a href="{{route('invoice.show',$inv->id)}}"><i class="fa fa-eye"></i></a>&nbsp;&nbsp;&nbsp;<a href="{{route('pdf',$inv->id)}}"><i class="fa fa-download"></i></a></td>

                                </tr>
                                @empty
                                <tr><th colspan="8" align="center">No Record Found..!!!</th></tr>
                            @endforelse
                            </tbody>
                        </table>
                        {{--<span>{{$invoice->onEachSide(1)->links()}}</span>--}}
                    </div>
                </div>



            </div>
        </div>
    </section>
    <!--PRICING AREA END-->
@endsection